package ch.fritteli.gombaila.domain.lexer;

import org.jetbrains.annotations.Nullable;

public class LexerException extends RuntimeException {
    private final int lineNumber;
    private final int colNumber;

    public LexerException(@Nullable final String s, final int line, final int column) {
        super(s);
        this.lineNumber = line;
        this.colNumber = column;
    }

    @Override
    public String getMessage() {
        return "Lexer error at line %d, position %d: %s".formatted(
                this.lineNumber,
                this.colNumber,
                super.getMessage()
        );
    }
}
