package ch.fritteli.gombaila.domain.lexer;

import ch.fritteli.gombaila.ElementWalker;
import org.jetbrains.annotations.NotNull;

public class StringWalker extends ElementWalker<String, Character> {
    private int line = 0;
    private int column = 0;

    public StringWalker(@NotNull final String string) {
        super(
                string,
                (back, index) -> index < back.length(),
                String::charAt
        );
    }

    public int line() {
        return this.line + 1;
    }

    public int column() {
        return this.column + 1;
    }

    @NotNull
    @Override
    public Character next() {
        final char c = super.next();
        if (c == '\n') {
            this.line++;
            this.column = 0;
        } else {
            this.column++;
        }
        return c;
    }
}
