package ch.fritteli.gombaila.domain.parser;

import ch.fritteli.gombaila.domain.common.Token;
import org.jetbrains.annotations.Nullable;

public class ParserException extends RuntimeException {
    @Nullable
    private final Token token;

    public ParserException(@Nullable final String s, @Nullable final Token token) {
        super(s);
        this.token = token;
    }

    @Override
    public String getMessage() {
        return "Parser error at token '%s': %s".formatted(
                this.token,
                super.getMessage()
        );
    }
}
