package ch.fritteli.gombaila.domain.printer;

import org.jetbrains.annotations.NotNull;

record RawLine(@NotNull String line, int indentationLevel, @NotNull WidthMap widthMap) implements Line {
    @Override
    public void updateWithMap() {
        // nop
    }

    @NotNull
    @Override
    public String toString() {
        final int indents = this.widthMap.getIndentationSize() * this.indentationLevel;
        if (indents == 0) {
            return this.line;
        }
        return ("%-" + indents + "s%s").formatted("", this.line);
    }
}
